Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 502386 - app-text/ghostscript-gpl[cups] USE enforced for no reason while updating.
Summary: app-text/ghostscript-gpl[cups] USE enforced for no reason while updating.
Status: CONFIRMED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core - Dependencies (show other bugs)
Hardware: All Linux
: Normal major (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2014-02-25 08:34 UTC by dE
Modified: 2014-03-11 08:18 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge output (with_autounmask,40.81 KB, text/plain)
2014-02-25 08:34 UTC, dE
Details
emerge -pvd --getbinpkg dev-java/icedtea-bin virtual/jdk virtual/jre &> debug.log (debug.log.xz,116.74 KB, application/x-xz)
2014-03-11 07:47 UTC, dE
Details

Note You need to log in before you can comment on or make changes to this bug.
Description dE 2014-02-25 08:34:54 UTC
Created attachment 371204 [details]
emerge output

emerge -pv --update --deep --getbinpkg --tree world

results in the attached log.

emerge -pv --update --deep --getbinpkg --tree --autounmask=n world

results in --

These are the packages that would be merged, in reverse order:

Calculating dependencies                                 ... done!

emerge: there are no ebuilds built with USE flags to satisfy "app-text/ghostscript-gpl[cups]".
!!! One of the following packages is required to complete your request:
- app-text/ghostscript-gpl-9.10-r2::gentoo (Change USE: +cups)
(dependency required by "net-print/cups-1.7.1" [ebuild])
(dependency required by "dev-java/icedtea-bin-7.2.3.4" [installed])
(dependency required by "virtual/jdk-1.7.0" [installed])
(dependency required by "virtual/jre-1.7.0" [installed])
(dependency required by "@selected" [set])
(dependency required by "@world" [argument])

Tried 

emerge -pv --getbinpkg dev-java/icedtea-bin virtual/jdk virtual/jre

These are the packages that would be merged, in order:

Calculating dependencies                        ... done!               
[ebuild  NS    ] virtual/jpeg-62:62 [0:0] ABI_X86="(64) (-32) (-x32)" 0 kB
[ebuild  N F   ] dev-java/oracle-jdk-bin-1.7.0.51-r1:1.7  USE="X alsa nsplugin (-aqua) -derby -doc -examples -fontconfig -jce -pax_kernel -source" 134,961 kB
[ebuild   R   ~] virtual/jdk-1.7.0:1.7  0 kB
[ebuild   R   ~] virtual/jre-1.7.0:1.7  0 kB
[ebuild  NS    ] dev-java/icedtea-bin-6.1.12.7:6 [7.2.3.4:7] USE="X alsa nsplugin -cjk -cups -doc -examples -source" 39,076 kB

Total: 5 packages (1 new, 2 in new slots, 2 reinstalls), Size of downloads: 174,036 kB
Fetch Restriction: 1 package (1 unsatisfied)

Thus either -- 

1) Portage is installing cups for no reason
2) app-text/ghostscript-gpl[cups] enforced for no reason.

Portage 2.2.8_p58 (default/linux/amd64/13.0/desktop/kde, gcc-4.8.2, glibc-2.15-r3, 3.8.5-gentoo x86_64)
=================================================================
System uname: Linux-3.8.5-gentoo-x86_64-Intel-R-_Core-TM-_i3-2120_CPU_@_3.30GHz-with-gentoo-2.2
KiB Mem:     8119296 total,    406764 free
KiB Swap:   17825788 total,  17825772 free
Timestamp of tree: Tue, 25 Feb 2014 05:30:01 +0000
ld GNU ld (GNU Binutils) 2.23.2
app-shells/bash:          4.2_p45
dev-java/java-config:     2.1.12-r1
dev-lang/python:          2.7.5-r3, 3.2.5-r3, 3.3.3
dev-util/pkgconfig:       0.28
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.12.4
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.69
sys-devel/automake:       1.13.4
sys-devel/binutils:       2.23.2
sys-devel/gcc:            4.8.2
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r4
sys-kernel/linux-headers: 3.8 (virtual/os-headers)
sys-libs/glibc:           2.15-r3
Repositories: gentoo x11 sunrise wish mistafunk bitcoin my-tree
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -O2 -fomit-frame-pointer -flto -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/splash /etc/terminfo"
CXXFLAGS="-march=native -O2 -fomit-frame-pointer -flto -pipe"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--with-bdeps=n --complete-graph --binpkg-respect-use=y"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs candy config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j4"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/var/lib/layman/x11 /var/lib/layman/sunrise /var/lib/layman/wish /var/lib/layman/mistafunk /var/lib/layman/bitcoin /home/de/dev-tree"
USE="X a52 a53 aac aalib acc acpi adns alsa amd64 amr atm audiofile branding bzip2 cdr cli consolekit cracklib css custom-cflags custom-optimization dbus dbx declarative dga dirac dri dts dv dvd dvdr emboss encode enscript exif ffmpeg firefox flac fortran gdu gif gles glut gmp gsm gstreamer gzip iconv imlib ipc jit jpeg jpeg2k kde ladspa lame lcms libedit libnotify libsamplerate libwww lzma lzo mad matroska matrox mikmod mime minimal mmap mmx mng modules mozilla mp3 mp4 mpeg mplayer mudflap multilib musepack networkmanager nntp nocd nptl nptlonly nsplugin offensive ogg openal opencl openexr opengl openmp optimization orc osc pam pango pdf phonon plasma png policykit posix ppds pppd qt3support qt4 quicktime raw readline schroedinger sharedmem shorten smp sndfile sockets socks5 speex spell sse sse2 sse3 sse4 sse4_1 ssse3 startup-notification strong-optimization svg symlink sysfs taglib tcpd theora threads tiff toolame truetype twolame udev udisks unicode upower usb vaapi vcd vhosts vorbis wavpack win32codecs wmf wxwidgets x264 xcb xcomposite xine xinerama xml xorg xpm xv xvid xvmc zlib" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="nlpsolver pdfimport" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_3" QEMU_SOFTMMU_TARGETS="x86_64" QEMU_USER_TARGETS="arm" RUBY_TARGETS="ruby19 ruby18" USERLAND="GNU" VIDEO_CARDS="intel fglrx i915" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LANG, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, SYNC, USE_PYTHON
Comment 1 dwfreed 2014-02-25 15:59:39 UTC
icedtea-bin has an RDEPEND on cups via the X use flag.  cups subsequently has a PDEPEND on ghostscript-gpl[cups], and so it's actually required.  When not using -NDu @world, portage assumes that installed packages have their dependencies properly satisfied, and so won't notice if they're not, which is why your third command doesn't try to install cups, because icedtea-bin is already installed.
Comment 2 dE 2014-03-01 03:58:50 UTC
(In reply to dwfreed from comment #1)
> icedtea-bin has an RDEPEND on cups via the X use flag.  cups subsequently
> has a PDEPEND on ghostscript-gpl[cups], and so it's actually required.  When
> not using -NDu @world, portage assumes that installed packages have their
> dependencies properly satisfied, and so won't notice if they're not, which
> is why your third command doesn't try to install cups, because icedtea-bin
> is already installed.

I wouldn't call that expected behavior.

I mean I even got --complete-graph enabled in make.conf.
Comment 3 Sebastian Luther (few) 2014-03-01 06:26:40 UTC
(In reply to dE from comment #0)
> emerge -pv --getbinpkg dev-java/icedtea-bin virtual/jdk virtual/jre
> 
> These are the packages that would be merged, in order:
> 
> Calculating dependencies                        ... done!               
> [ebuild  NS    ] virtual/jpeg-62:62 [0:0] ABI_X86="(64) (-32) (-x32)" 0 kB
> [ebuild  N F   ] dev-java/oracle-jdk-bin-1.7.0.51-r1:1.7  USE="X alsa
> nsplugin (-aqua) -derby -doc -examples -fontconfig -jce -pax_kernel -source"
> 134,961 kB
> [ebuild   R   ~] virtual/jdk-1.7.0:1.7  0 kB
> [ebuild   R   ~] virtual/jre-1.7.0:1.7  0 kB
> [ebuild  NS    ] dev-java/icedtea-bin-6.1.12.7:6 [7.2.3.4:7] USE="X alsa
> nsplugin -cjk -cups -doc -examples -source" 39,076 kB
> 

There's only one way --complete-graph would ignore dependencies. This is when the package is not reachable from @world.

Please attach the debug.log created by:
emerge -pvd --getbinpkg dev-java/icedtea-bin virtual/jdk virtual/jre &> debug.log
Comment 4 dE 2014-03-11 07:47:04 UTC
Created attachment 372352 [details]
emerge -pvd --getbinpkg dev-java/icedtea-bin virtual/jdk virtual/jre &> debug.log
Comment 5 dE 2014-03-11 08:14:18 UTC
Same thing with dev-java/icedtea.

emerge: there are no ebuilds built with USE flags to satisfy "app-text/ghostscript-gpl[cups]".
!!! One of the following packages is required to complete your request:
- app-text/ghostscript-gpl-9.10-r2::gentoo (Change USE: +cups)
(dependency required by "net-print/cups-1.7.1" [ebuild])
(dependency required by "dev-java/icedtea-6.1.13.1" [ebuild])
(dependency required by "dev-java/icedtea-web-1.3.2" [ebuild])

Neither dev-java/icedtea or dev-java/icedtea-web requires cups or app-text/ghostscript-gpl when compiling without cups.
Comment 6 dE 2014-03-11 08:18:22 UTC
(In reply to dE from comment #5)
> Same thing with dev-java/icedtea.
> 
> emerge: there are no ebuilds built with USE flags to satisfy
> "app-text/ghostscript-gpl[cups]".
> !!! One of the following packages is required to complete your request:
> - app-text/ghostscript-gpl-9.10-r2::gentoo (Change USE: +cups)
> (dependency required by "net-print/cups-1.7.1" [ebuild])
> (dependency required by "dev-java/icedtea-6.1.13.1" [ebuild])
> (dependency required by "dev-java/icedtea-web-1.3.2" [ebuild])
> 
> Neither dev-java/icedtea or dev-java/icedtea-web requires cups or
> app-text/ghostscript-gpl when compiling without cups.

Ok, got it. DEPEND is on icedtea-bin